#include <i2c_8x2lcd.h>
#include <Wire.h>


I2C_8X2LCD::I2C_8X2LCD(){


}

I2C_8X2LCD::I2C_8X2LCD(int vccpin,int gndpin){
  pinMode(gndpin, OUTPUT);
  digitalWrite(gndpin, LOW);
  pinMode(vccpin, OUTPUT);
  digitalWrite(vccpin, HIGH);
}

void I2C_8X2LCD::init(int contrast){
  delay(500);
  Wire.begin();
  lcd_cmd(0b00111000); // function set
  lcd_cmd(0b00111001); // function set
  lcd_cmd(0b00000100); // EntryModeSet
  lcd_cmd(0b00010100); // interval osc
  lcd_cmd(0b01110000 | (contrast & 0xF)); // contrast Low
  lcd_cmd(0b01011100 | ((contrast >> 4) & 0x3)); // contast High/icon/power
  lcd_cmd(0b01101100); // follower control
  delay(200);
  lcd_cmd(0b00111000); // function set
  lcd_cmd(0b00001100); // Display On
  lcd_cmd(0b00000001); // Clear Display
  delay(2);
}

void I2C_8X2LCD::lcd_cmd(byte x) {
  Wire.beginTransmission(I2Cadr);
  Wire.write(0b00000000); // CO = 0,RS = 0
  Wire.write(x);
  Wire.endTransmission();
}
 
void I2C_8X2LCD::contdata(byte x) {
  Wire.write(0b11000000); // CO = 1, RS = 1
  Wire.write(x);
}
 
void I2C_8X2LCD::lastdata(byte x) {
  Wire.write(0b01000000); // CO = 0, RS = 1
  Wire.write(x);
}
 
void I2C_8X2LCD::printStr(byte x,byte y,const char *s){
	setCursor(x,y);
	printStr(s);
}
 
// ̕\
void I2C_8X2LCD::printStr(const char *s) {
  Wire.beginTransmission(I2Cadr);
  while (*s) {
    if (*(s + 1)) {
      contdata(*s);
    } else {
      lastdata(*s);
    }
    s++;
  }
  Wire.endTransmission();
}

void I2C_8X2LCD::printInt(int num)
{
  char int2str[10]; 
  sprintf(int2str,"%d",num);
  printStr(int2str);	
}

// \ʒu̎w
void I2C_8X2LCD::setCursor(byte x, byte y) {
  lcd_cmd(0x80 | (y * 0x40 + x));
}

void I2C_8X2LCD::setContrast(byte c) {

  lcd_cmd(0x39);
  lcd_cmd(0b01110000 | (c & 0x0f)); // contrast Low
  lcd_cmd(0b01011100 | ((c >> 4) & 0x03)); // contast High/icon/power
  lcd_cmd(0x38);
}

void I2C_8X2LCD::clear(){
  printStr(0,0,"        ");
  printStr(0,1,"        ");
}